
#include "blocks.h"
#include "iir_dir_float.h"
#include "iir_cas_float.h"


/* global variables */

struct_iir_dir_float dir_data;
struct_iir_cas_float cas_data;


#define ORDER 1

/* direct form coefficients */
float dir_a[ORDER]   = { 0.9 };
float dir_b[ORDER+1] = { 1., 0.};


//#define NCASCADES ORDER/2  /* we assume an even order */

#define NCASCADES 1
/* cascade form coefficients */
float cas_coeffs[NCASCADES*4+1] = { -0.9, 0., 0., 0., 1. };

#pragma DATA_ALIGN(cas_coeffs, 8); /* necessary for optimized assembly biquad core */




/* object initialization */
void init( void)
{
  iir_dir_float_init( &dir_data, dir_b, dir_a, ORDER, BLKSZ);
  iir_cas_float_init( &cas_data, cas_coeffs, NCASCADES, BLKSZ);  
}


/* realtime block processing */
void processing( void * sigbuf)
{
  /* only one function should be active here */
  iir_dir_float( &dir_data, (float *)sigbuf);  /* direct form */
  //iir_cas_float( &cas_data, (float *)sigbuf);  /* cascade form */
}
