
#include "iir_cas_float.h"
#include <stdlib.h>


float biquad(int num_cas, float *coeffs, float *states, float in);
/* definition in biquad_float.asm */




void iir_cas_float_init( struct_iir_cas_float *data, float *coeffs, unsigned num_cas, unsigned blksz)
{
  data->num_cas = num_cas;
  data->blksz = blksz;
  data->coeffs = coeffs;
  data->gain = coeffs[num_cas*4];
  data->states = (float *)memalign( 8, 2 * num_cas * sizeof( float));
}


void iir_cas_float( struct_iir_cas_float *data, float *sigbuf)
{
  int i;
  for( i=0; i<data->blksz; i++)
    sigbuf[i] = data->gain * biquad( data->num_cas, data->coeffs, data->states, sigbuf[i]);
}
