

#include "iir_dir_float.h"
#include <stdlib.h>


void iir_dir_float_init( struct_iir_dir_float *data, float *b, float *a, unsigned order, unsigned blksz)
{
  data->order = order;
  data->blksz = blksz;
  data->a = a;
  data->b = b;
  data->states = (float *)malloc( order * sizeof( float));
  memset( data->states, 0, order * sizeof( float));
  data->cur = 0;
}


void iir_dir_float( struct_iir_dir_float *data, float *sigbuf)
{
  float w, y, d;
  int i, s;  
  for( s = 0; s < data->blksz; s++) /* sample by sample */
  {
    for( i = 0, w = sigbuf[s], y = 0; i < data->order; i++)
    { 
      d = data->states[ (data->cur + i) % data->order ];
      w -= data->a[ data->order-i-1 ] * d;
      y += data->b[ data->order-i ]   * d;
    }
    y += data->b[0] * w;
    sigbuf[s] = y;    
    data->states[ data->cur++ ] = w;
    data->cur %= data->order;  
  }
}
